// lzw_compression.h: interface for the lzw::compression class.
//
//////////////////////////////////////////////////////////////////////
#ifndef _LZW_COMRESSION_H_
#define _LZW_COMRESSION_H_

#include "lzw_dictionary.h"

namespace lzw
{
    class compression
    {
    public:
        compression     (unsigned int heap_size_in_bytes = 32*1024*1024, bool expanded = false);
        ~compression    ();

        size_t          compress            (const char* source, size_t length, char* destination, size_t limit) ;
        size_t          decompress          (const char* source, size_t length, char* destination, size_t limit) ;

        void            dump_dictionary     () ;
        void            metrics             () ;

        static const unsigned int    not_in_dictionary = (unsigned int)-1;

    private:
        void            reset               ();
        void            calculate_bit_size  (unsigned int value);

        void            compress_data       (char* destination, size_t& index, size_t length, unsigned int data) ;
        unsigned int    decompress_data     (const char* source, size_t& index, size_t length) ;

        unsigned int    _maxbits;
        unsigned int    _done;
        int             _totalbits;
        unsigned int    _saveddata;

        dictionary      _dictionary;
    };
}

#endif // _LZW_COMRESSION_H_
